/*
  Last changed Time-stamp: <2010-11-10 23:12:04 xtof>
  $Id: FileFormats.h,v 1.4 2010/11/10 23:21:01 xtof Exp $
*/
#ifndef _FILEFORMATS_H_
#define _FILEFORMATS_H_

#include "TypeDefs.h"

Alignment_t
parse_multi_fasta_alignment (char* infile);
void
print_multi_fasta_alignment(std::pair<std::vector<std::string>,
			    std::vector<std::string> > p);
DblSqrMatrix_t
read_distance_matrix_from_file(char *filename, int size);
void
print_output (Alignment_t aln, Statistic_t stat, std::string basename);
void
print_multi_fasta_alignment_to_file (Alignment_t aln, std::string filename);
void
print_statistics_to_file(Statistic_t stat,
			 std::vector<std::string> reduced,
			 std::vector<double> smoothed,
			 std::vector<int> order,
			 double rp,
			 double cutoff,
			 char *optStr, std::string basename);
void
print_type_overview_to_file(Statistic_t stat,
			    std::vector<std::string> taxa,
			    double cutoff,
			    std::string basename);
void
print_idx_to_file(std::vector<int> keep_idx,
		  std::string basename);

#endif

/* End of file */
