/*
  Last changed Time-stamp: <2006-03-30 01:10:20 xtof>
  $Id: Maps.cpp,v 1.1.1.1 2006/04/11 14:53:52 xtof Exp $
*/
#include <iostream>
#include <map>
#include <string>

#include "Maps.h"

CharIntMap_t
CharIntMap_new_from_char_array(char *s)
{
  CharIntMap_t mmap;
  std::string missing(s);

  for (std::string::const_iterator symbol = missing.begin();
       symbol != missing.end();
       symbol++)
    mmap[*symbol]++;  // better mmap.insert(make_pair(*symbol, 1));

  return (mmap);
}

bool
CharIntMap_exists(char key, CharIntMap_t m)
{
  if (m.find(key) != m.end())
    return (true);
  else
    return (false);  
}

std::string
CharIntMap_keys(CharIntMap_t m)
{
  std::string keys = std::string();
  for (CharIntMultiMap_t::iterator entry = m.begin();
       entry != m.end();
       entry++) {
    keys.push_back((*entry).first);
  }
  
  return (keys);
}

CharIntMultiMap_t
CharIntMultiMap_new_from_string(std::string s)
{
  CharIntMultiMap_t mmap;
  for (std::string::const_iterator symbol = s.begin();
       symbol != s.end();
       symbol++)
    mmap.insert(std::make_pair(*symbol,1));

  return (mmap);
}

std::string
CharIntMultiMap_keys(CharIntMultiMap_t m)
{
  std::string keys = std::string();
  for (CharIntMultiMap_t::iterator entry = m.begin();
       entry != m.end();
       entry++) {
    keys.push_back((*entry).first);
  }
  
  return (keys);
}

// End of file
