/*
  Last changed Time-stamp: <2010-11-10 22:37:19 xtof>
  $Id: TypeDefs.h,v 1.3 2010/11/10 23:21:01 xtof Exp $
*/
#ifndef _TYPEDEFS_H_
#define _TYPEDEFS_H_

#include <vector>

struct _INTTRIPLET
{
  int A, B, C;
};

struct _DOUBLETRIPLET
{
  double A, B, C;
};

struct _ColumnData
{
  std::string column; // alignment column
  char c_type;        // type of alignemnt column
  int c_idx;          // index of column in alignemt
  double p_value;     // p-value of alignment column
};

typedef struct _ColumnData ColumnData_t;

typedef std::pair<std::vector<std::string>,
                  std::vector<int> > Result_t;

typedef std::pair<std::vector<std::string>,
                  std::vector<std::string> > Alignment_t;

typedef std::pair<std::vector<double>,
                  std::string> Statistic_t;

typedef std::vector<std::vector<double> > DblSqrMatrix_t;

typedef struct _INTTRIPLET INTTRIPLET;
typedef struct _DOUBLETRIPLET DOUBLETRIPLET;
typedef std::vector<DOUBLETRIPLET> QUARTET;
typedef std::vector<int> INTVEC;
typedef std::vector<INTVEC> INTINTVEC;
typedef std::vector<INTINTVEC> INTINTINTVEC;
typedef std::vector<double> DOUBLEVEC;
typedef std::vector<INTTRIPLET> INTTRIPLETVEC;
typedef std::vector<DOUBLETRIPLET> DOUBLETRIPLETVEC;

typedef std::vector<std::vector<double> > dbl_array;
typedef unsigned long word;

#endif

/* End of file */
