/*
  Last changed Time-stamp: <2009-02-06 19:06:13 xtof>
  $Id: Utils.h,v 1.9 2009/02/06 18:18:43 xtof Exp $
*/
#ifndef _UTILS_H_
#define _UTILS_H_

#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <string>
#include <vector>

#include "mt19937ar.h"

// Constants
#define BIG_NUMBER 1000000 //Used in all maximisation loops
#define BIG_FLOAT 1.0e300
// Macros
#define ABS(g) ((g>0) ? (g) : -(g))
#define MAX(A,B) ((A) > (B) ? (A) : (B))
#define MIN(A,B) ((A) < (B) ? (A) : (B))
// Dignostic helper function(s)
void
Fatal(char *fmt, ...);
void
Warn(char *fmt, ...);
void
error_message(const std::string & message);
char *
timeStamp(void);
// IO helper function(s)
void
print_dbl_2Darray(std::vector<std::vector<double> > a);
void
pretty_print(FILE *hdl, char const *fmt, ...);
void
print_int_array(std::vector<int> v);
void
print_dbl_array(std::vector<double> v);
void
print_chr_array(std::string v);
// String helper function(s)
std::string
format(char const *fmt, ...);
std::string
random_shuffle(const std::string & source);
std::string
upper_case(const std::string & source);
std::string
lower_case(const std::string & source);
std::vector<int>
to_int_array(std::vector<std::string> strs);
std::vector<std::string>
split_at(const std::string& source, const std::string& seperator = ",");
std::string
trim_right(const std::string & source, const std::string & t = " ");
std::string
StripPath(const std::string & source, const std::string & t = "/");
std::string
StripExtension(const std::string & source, const std::string & t = ".");
std::string
trim_left(const std::string & source, const std::string & t = " ");
std::string
trim(const std::string & source, const std::string & t = " \r");
std::string
fasta_extract_name(const std::string & source);
// Nummeric helper function(s)
int
over4 (int n);
int
over3 (int n);
int
over2 (int n);
int
over1 (int n);
// Misc helper function(s)
void
init_rand(void);
double
urn(void);
int
int_urn(int from, int to);

class RandomNumber {
 public:
  RandomNumber() {
    init_genrand(time(0));
    //    srand(time(0));
  }
    
  int operator() ( int n) {
    return (int)((unsigned long)n * genrand_real2());
  }
};

// Memory helper function(s)
void
allocate_dbl_sqr_array(std::vector<std::vector<double> > & A, int size);

#endif

/* End of file */
