#ifndef _HOLDERS_H
#define _HOLDERS_H

#include <vector>
#include "TypeDefs.h"

// *** WHolder *** //

class WHolder {
 private:
  INTTRIPLETVEC counts;
  DOUBLETRIPLETVEC weights;

 public:
  WHolder (INTINTVEC, int, QUARTET);
  int getN (int, int, int, int);
  void setN (int, int, int, int, int);
  double getW (int, int, int, int);
  void setW (int, int, int, int, double);
};

// *** end of WHolder *** //

// *** NSHolder *** //

class NSHolder {
 private:
  INTVEC counts;
  DOUBLEVEC weights;

 public:
  NSHolder (INTINTVEC, int, QUARTET);
  int getN (int, int);
  void setN (int, int, int);
  double getS (int, int);
  void setS (int, int, double);
};

// *** end of NSHolder *** //

// *** THolder *** //

class THolder {
 private:
  INTINTINTVEC counts;
  std::vector<std::vector<std::vector<double> > > weights;

 public:
  THolder (INTINTVEC, int, QUARTET);
  int getN (int, int, int);
  void setN (int, int, int, int);
  double getT (int, int, int);
  void setT (int, int, int, double);
};

// *** end of THolder *** //

// *** U0Holder *** //

class U0Holder {
 private:
  INTVEC counts;
  DOUBLEVEC weights;

 public:
  U0Holder (INTINTVEC, int, QUARTET);
  int getN (int, int);
  void setN (int, int, int);
  double getU (int, int);
  void setU (int, int, double);
};

// *** end of U0Holder *** //

// *** U1Holder *** //

class U1Holder {
 private:
  INTVEC counts;
  DOUBLEVEC weights;

 public:
  U1Holder (INTINTVEC, int, QUARTET);
  int getN (int, int);
  void setN (int, int, int);
  double getU (int, int);
  void setU (int, int, double);
};

// *** end of U1Holder *** //

// *** ZHolder *** //

class ZHolder {
 private:
  INTVEC sizes;
  int z (INTINTVEC, int);
 
 public:
  ZHolder (INTINTVEC, int);
  int getZ (int);
  void setZ (int, int);
};

// *** end of ZHolder *** //

#endif
