/*
  Last changed Time-stamp: <2006-06-23 19:00:47 xtof>
  $Id: options.h,v 1.2 2006/06/23 18:33:39 xtof Exp $
*/
#ifndef _OPTIONS_H_
#define _OPTIONS_H_

#if __cplusplus
#  define BEGIN_C_DECLS extern "C" {
#  define END_C_DECLS   }
#else
#  define BEGIN_C_DECLS
#  define END_C_DECLS
#endif

BEGIN_C_DECLS

typedef struct _Options {
  char ExeName[256]; /* name of executabel */
  char InName[256];  /* name of input file */
  char Missing[256]; /* array with missing data characters */
  char DistMethod[256]; /* */
  char OrdMethod[256];
  char DistMx[256];  /* filname for distance matrix */
  char SeqType;      /* set sequence type of input alignmen */
  double CutOff;     /* lower bond for p-values of columns */
  int Silent;        /* turn off progress bar */
  int ReOrder;       /* use neighbor net to reorder alignment only */
  int NoGap;         /* ignore gap symbols in shuffling step */
  int NoConstant;    /* ignore constant sites in output alignment */
  int Shuffles;      /* number of shuffling steps per column */
  int Smooth;        /* running avarage */
  int Verbose;       /* verbosity mode */
  int SampleSize;    /* sample size for ordering random permutation */
} OptionS;

OptionS *
decodeCML(int argc, char *argv[]);
char*
optionString(void);

END_C_DECLS

#endif /* _OPTIONS_H_ */

/* End of file */
